
Redmine - Feature #15201

Filter "Assignee" should contain locked users

2013-10-25 11:43 - Jan Niggemann (redmine.org team member)

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Issues filter Estimated time: 0.00 hour

Target version: 4.0.0   

Resolution: Fixed   

Description

Scenario

User leaves company -> profile gets locked

User still has issues assigned, but it's not possible to set a filter "Assignee=UserWhoLeft"

Related issues:

Related to Redmine - Feature #11069: Ability to search tasks of Locked Users Closed

Related to Redmine - Feature #24568: Show locked users in 'Users' filter for ... Closed

Related to Redmine - Defect #39232: Locked users in filters only visible to a... New

Related to Redmine - Defect #41079: Incorrect sorting of users grouped by sta... Closed

Has duplicate Redmine - Defect #15602: Can not filter issues with criteria as... Closed

Associated revisions

Revision 17371 - 2018-06-09 10:07 - Go MAEDA

Include locked members in filters (#15201).

Patch by Marius BALTEANU.

History

#1 - 2013-10-25 14:22 - Gurvan Le Dromaguet

I suppose the best would be an option in Redmine settings to allow or not the querying on locked users.

#2 - 2013-10-26 08:38 - Mischa The Evil

Jan Niggemann (redmine.org team member) wrote:

Scenario

User leaves company -> profile gets locked

User still has issues assigned, but it's not possible to set a filter "Assignee=UserWhoLeft"

 Indeed, at least not using the UI. Using some URL mangling (see #4501, #8160 and #13443) you can still create a query using locked users as

assignee.

Working example of formatted URL where user with ID 10 is locked...Working example of formatted URL where user with ID 10 is locked...

http://redmine.host.tld/projects/demoproject/issues?utf8=%E2%9C%93&set_filter=1

                                                   &f%5B%5D=status_id

                                                   &op%5Bstatus_id%5D=o

                                                   &f%5B%5D=assigned_to_id

                                                   &op%5Bassigned_to_id%5D=%3D

                                                   &v%5Bassigned_to_id%5D%5B%5D=10

                                                   &f%5B%5D=

                                                   &c%5B%5D=tracker

                                                   &c%5B%5D=status

                                                   &c%5B%5D=priority

                                                   &c%5B%5D=subject

                                                   &c%5B%5D=assigned_to

                                                   &c%5B%5D=updated_on

                                                   &group_by=

If it is decided that locked users are getting included in possible filter values, I'd strongly prefer to distinct them clearly (using HTML optgroup or so).
#3 - 2013-10-26 08:46 - Jean-Philippe Lang

- Tracker changed from Defect to Feature

#4 - 2013-12-05 16:43 - Toshi MARUYAMA

- Has duplicate Defect #15602: Can not filter issues with criteria assigned_to equal to an unaffected user who previously worked on the project added

#5 - 2014-03-05 09:17 - Luis Serrano Aranda

I think you should add this feature for more filters like autor, and all the filters with a user.

#6 - 2014-08-15 15:56 - Deoren Moor

+1

This would really come in handy.

#7 - 2014-09-14 07:23 - Toshi MARUYAMA

- Related to Feature #11069: Ability to search tasks of Locked Users added

#8 - 2015-06-22 10:49 - Ismael Barros²

+1

#9 - 2016-04-22 09:59 - Christophe Portier

+1

#10 - 2016-05-02 13:56 - Henning Kröger

+1

We are missing locked users in the filters for time entries too. I think this is related to this issue, do you agree?

#11 - 2016-05-13 05:47 - Toshi MARUYAMA

- Category changed from Issues to Issues filter

#12 - 2016-10-10 11:00 - Stephane Lapie

+1

#13 - 2016-10-20 13:50 - Sonia Zh

+1

and agree as well with Henning Kroger regarding time_entries. If someone left from the company half way of a version and we want to display the

timelog report for all issues related to the version. The timelog from the locked-user won't appear in the timelog report. The total hours spent for the

released version won't be correct.

#14 - 2017-05-08 14:14 - Jürgen Depicker

+1

and same remark regarding spent time on an issue (timelog report) - time logs should still show hours spent by users who are no longer active, since

the time was spent (and paid) after all :).

#15 - 2017-05-08 14:17 - Jürgen Depicker

Related to #24568.

#16 - 2017-05-14 08:49 - Marius BĂLTEANU

- File 15201_include_locked_members_in_assignee_users.patch added

I've attached a small patch that adds the locked members to the assignee and author values. I think it's the expected behaviour from two reasons:

- there are a lot of cases when you want to find tickets created/assigned to a locked member, especially when a user left the company and you want

to find his issues.

- the members page includes the locked members (#22034).

The patch fixes also #24568.

#17 - 2017-06-01 23:07 - Mischa The Evil

- Target version set to Candidate for next major release
I agree with Marius' rationale for the change. I think this would be good improvement.

#18 - 2017-06-06 19:25 - Toshi MARUYAMA

- Related to Feature #24568: Show locked users in 'Users' filter for 'Spent time' report added

#19 - 2017-07-03 17:57 - Marius BĂLTEANU

Let's try fixing this behavior in 3.4.1 or version:3.5.0.

#20 - 2017-07-03 19:58 - Mischa The Evil

Marius BALTEANU wrote:

Let's try fixing this behavior in 3.4.1 or version:3.5.0.

 I would support integration of this change into 3.5.0 if we also add a distinction between the locked users and the active users using a HTML

optgroup.

I know several situations where the amount of locked users if way bigger than the number of active users. In these situations, application of the

current proposed patch would make the author and assigned_to filters pretty hard to work with. WDYT?

#21 - 2017-07-19 17:02 - Marius BĂLTEANU

Totally agree, I'll update the patch in order to group the assignee by status.

#22 - 2017-09-25 23:51 - Marius BĂLTEANU

- File group_by_status.png added

- File author_by_status.png added

Mischa, something like that it is good enough?

 group_by_status.png 

Also, I think that the Author filter should have the same behaviour:

 author_by_status.png 

#23 - 2017-10-08 19:04 - Marius BĂLTEANU

- File 15201_include_locked_members_in_assignee_users_v2.patch added

Updated the patch to group users by status for the following filters:

Issue assignee

Issue author

TimeEntry user

#24 - 2017-10-09 00:56 - Mischa The Evil

Marius BALTEANU wrote:

Mischa, something like that it is good enough?

 Looking at the screenshots and after a quick scan of the patch content (with the tests) I'd say: LGTM!

#25 - 2017-10-25 07:15 - Toshi MARUYAMA

- Target version changed from Candidate for next major release to 4.1.0

#26 - 2018-02-08 10:32 - Christian Slam

Is there a permission to set, that all users can see the locked users in filters? atm only redmine admins can see them.

#27 - 2018-02-11 19:54 - Marius BĂLTEANU

Christian Slam wrote:

Is there a permission to set, that all users can see the locked users in filters? atm only redmine admins can see them.

 No, you can't see (yet) the locked users in filters regardless your user type or permissions. This feature is proposed for the next major Redmine

version.
If you need the feature early, you can try apply the patch on your instance, but you need some technical skills to do that. If you need help, please use

forums.

#28 - 2018-06-09 10:07 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Priority changed from Low to Normal

- Target version changed from 4.1.0 to 4.0.0

- Resolution set to Fixed

Committed. Thank you for improving Redmine.

#29 - 2018-11-27 10:03 - ryou soda

- File without_sysadmin.png added

- File with_sysadmin.png added

The system administrator only includes locked users in the assignee filter, is this the expected behavior?

●Not a system administrator

 

●System administrator

 

#30 - 2022-06-13 14:35 - Sebastian Paluch

This implementation does not meet its purpose. In 4.1.1 only system administrator can see locked users on the list. Project members are not able to

see locker users. This feature should be reopen.

#31 - 2023-10-24 09:28 - Turnip Zoink

New ticket: #39232.

#32 - 2023-11-30 04:08 - Mischa The Evil

- Related to Defect #39232: Locked users in filters only visible to administrators added

#33 - 2023-12-13 21:30 - Han Boetes

Since we ran into the same problem, I wrote this script to find tickets owned by locked users, which runs from a cronjob and sends an email to

somewhere. I hope this might be useful.

#!/bin/sh

disabled_users=$(echo 'select id from users where status = 3;' | mysql -N redmine)

for du in $disabled_users; do echo "select project_id, id, assigned_to_id from issues where assigned_to_id = 

$du
 and ( status_id = 1 or status_id = 2 or status_id = 4 or status_id = 14 or status_id = 28 or status_id = 38 )

;" | mysql -N redmine; done | \

while read project id user; do

  # First check if the project is still active.

  PS=$(echo "select status from projects where id = $project" | mysql -N redmine)

  if [ "$PS" = 5 ]; then

    continue

  fi

  PN=$(echo "select name from projects where id = $project" | mysql -N redmine)

  user=$(echo "select login from users where id = $user" | mysql -N redmine)

  echo "Ticket $id in project '$PN' is assigned to '$user'" 

done

 
#  ./opentickets_formeremployees 

Ticket 34352 in project 'Konstruktionslaufzettel (Pegasus)' is assigned to 'm.foobar'

Ticket 34358 in project 'Konstruktionslaufzettel (Pegasus)' is assigned to 'm.foobar'

#34 - 2024-08-11 10:17 - Go MAEDA

- Related to Defect #41079: Incorrect sorting of users grouped by status in issue filters for administrators added

Files

15201_include_locked_members_in_assignee_users.patch 2.13 KB 2017-05-14 Marius BĂLTEANU

group_by_status.png 182 KB 2017-09-25 Marius BĂLTEANU

author_by_status.png 171 KB 2017-09-25 Marius BĂLTEANU

15201_include_locked_members_in_assignee_users_v2.patch 5.87 KB 2017-10-08 Marius BĂLTEANU

without_sysadmin.png 17.1 KB 2018-11-27 ryou soda

with_sysadmin.png 17.3 KB 2018-11-27 ryou soda
